'****************************************************************************
'       Et fontprogram af Jakob Krarup, m frit anvendes
'       lad venligst denne kommentar st
'       kommentarer til Jake@post5.tele.dk
'****************************************************************************

TYPE Ildtype
  Roed AS SINGLE
  Groen AS SINGLE
  Blaa AS SINGLE
END TYPE

DECLARE SUB HentFont ()
DECLARE SUB skriv (Tekst AS STRING, X%, Y%, Fontfarve%, Stoerrelse%, Skygge%, tid!)
DECLARE SUB VisFil (Filnavn AS STRING, AntalLinierIFilen%, VenstreMargin%, TopMargin%, Fontfarve%, Stoerrelse%, Skygge%, tid!)

DIM SHARED Alfabet(0 TO 839) AS STRING * 1, IldFarver AS Ildtype
DIM SHARED Farve(8) AS INTEGER, Tabel(8) AS INTEGER

COMMON SHARED SkaermBreddeIPixels%

'Her skal du skrive hvor mange pixels der er henover skrmen
' f.eks. er der 640 pixels i skrm mode 12
SCREEN 13       'kan vre en hvilken som helst skaerm til almindelig skrift
                'Skal vre screen 13 til ild.

SkaermBreddeIPixels% = 320
HentFont        'Her hentes fonten ind

Tabel(0) = 1    'Denne tabel holder 2 i index'ende til at skrive fonten med
Tabel(1) = 2
Tabel(2) = 4
Tabel(3) = 8
Tabel(4) = 16
Tabel(5) = 32
Tabel(6) = 64
Tabel(7) = 128

'Her er ildfarven sat til at vre rd - den kan du bare ndre
IldFarver.Roed = 0
IldFarver.Groen = 0
IldFarver.Blaa = 63

'Her kan du lave dit program!










'Dette er data til fonten - m ikke fjernes eller ndres
Font:
DATA    0 ,   2 ,  47 ,  47 ,   2 ,   0 ,   0 ,   3 ,   0 ,   3 ,   0 ,   0 ,  20 ,  62 ,  20 ,  62 ,  20 ,   0 ,  36 ,  42 , 107 ,  42 ,  16 ,   0 ,  32 ,  18 ,   8 ,   4 ,  34 ,   0 ,  60 ,  38 ,  41 ,  23 ,  32 ,   0 ,   0 ,   0 ,   4 ,   3
DATA    0 ,   0 ,  12 ,  30 ,  33 ,   0 ,   0 ,   0 ,   0 ,   0 ,  33 ,  30 ,  12 ,   0 ,  42 ,  28 ,  62 ,  28 ,  42 ,   0 ,   0 ,   8 ,  28 ,   8 ,   0 ,   0 ,   0 ,   0 ,  64 ,  48 ,   0 ,   0 ,   0 ,   8 ,   8 ,   8 ,   8 ,   0 ,   0 ,   0
DATA    0 ,  32 ,   0 ,   0 ,  32 ,  16 ,   8 ,   4 ,   2 ,   0 ,  30 ,  33 ,  33 ,  33 ,  30 ,   0 ,   0 ,  34 ,  63 ,  32 ,   0 ,   0 ,  34 ,  49 ,  49 ,  41 ,  38 ,   0 ,  18 ,  33 ,  37 ,  37 ,  26 ,   0 ,   8 ,  12 ,  10 ,  63 ,   8 ,   0
DATA   23 ,  37 ,  37 ,  37 ,  25 ,   0 ,  30 ,  37 ,  37 ,  37 ,  24 ,   0 ,   3 ,   1 ,  49 ,   9 ,   7 ,   0 ,  26 ,  37 ,  37 ,  37 ,  26 ,   0 ,   6 ,  41 ,  41 ,  41 ,  30 ,   0 ,   0 ,   0 ,  20 ,   0 ,   0 ,   0 ,   0 ,  64 ,  52 ,   0
DATA    0 ,   0 ,   8 ,  20 ,  34 ,  65 ,   0 ,   0 ,   0 ,  20 ,  20 ,  20 ,   0 ,   0 ,   0 ,  65 ,  34 ,  20 ,   8 ,   0 ,   6 ,   1 ,  81 ,   9 ,   6 ,   0 ,  30 ,  33 ,  45 ,  45 ,  14 ,   0 ,  60 ,  10 ,   9 ,  10 ,  60 ,   0 ,  63 ,  37
DATA   37 ,  37 ,  26 ,   0 ,  30 ,  33 ,  33 ,  33 ,  18 ,   0 ,  63 ,  33 ,  33 ,  33 ,  30 ,   0 ,  63 ,  41 ,  41 ,  33 ,  33 ,   0 ,  63 ,   9 ,   9 ,   1 ,   1 ,   0 ,  30 ,  33 ,  33 ,  41 ,  26 ,   0 ,  63 ,   8 ,   8 ,   8 ,  63 ,   0
DATA    0 ,  33 ,  63 ,  33 ,   0 ,   0 ,  16 ,  33 ,  33 ,  33 ,  31 ,   0 ,  63 ,  12 ,  12 ,  18 ,  33 ,   0 ,  63 ,  32 ,  32 ,  32 ,  32 ,   0 ,  63 ,   2 ,   4 ,   2 ,  63 ,   0 ,  63 ,   2 ,   4 ,   8 ,  63 ,   0 ,  30 ,  33 ,  33 ,  33
DATA   30 ,   0 ,  63 ,   9 ,   9 ,   9 ,   6 ,   0 ,  30 ,  33 ,  41 ,  17 ,  46 ,   0 ,  63 ,   9 ,   9 ,  25 ,  38 ,   0 ,  34 ,  37 ,  37 ,  37 ,  24 ,   0 ,   1 ,   1 ,  63 ,   1 ,   1 ,   0 ,  31 ,  32 ,  32 ,  32 ,  31 ,   0 ,  15 ,  16
DATA   32 ,  16 ,  15 ,   0 ,  31 ,  32 ,  24 ,  32 ,  31 ,   0 ,  33 ,  18 ,  12 ,  18 ,  33 ,   0 ,   3 ,   4 ,  56 ,   4 ,   3 ,   0 ,  33 ,  49 ,  41 ,  37 ,  35 ,   0 ,   0 ,   0 ,  63 ,  33 ,   0 ,   0 ,   3 ,   6 ,  12 ,  24 ,  48 ,   0
DATA    0 ,  33 ,  63 ,   0 ,   0 ,   0 ,   0 ,   2 ,   1 ,   2 ,   0 ,   0 ,   0 ,  64 ,  64 ,  64 ,  64 ,   0 ,   0 ,   0 ,   1 ,   2 ,   0 ,   0 ,   0 ,  16 ,  42 ,  42 ,  60 ,   0 ,   0 ,  63 ,  34 ,  34 ,  28 ,   0 ,   0 ,  28 ,  34 ,  34
DATA   34 ,   0 ,   0 ,  28 ,  34 ,  34 ,  63 ,   0 ,   0 ,  28 ,  42 ,  42 ,  44 ,   0 ,   0 ,   8 ,  62 ,   9 ,   2 ,   0 ,   0 , 156 , 162 , 162 , 126 ,   0 ,   0 ,  63 ,   2 ,   2 ,  60 ,   0 ,   0 ,   0 ,  61 ,   0 ,   0 ,   0 ,   0 , 128
DATA  125 ,   0 ,   0 ,   0 ,   0 ,  63 ,   8 ,  52 ,   0 ,   0 ,   0 ,   0 ,  63 ,   0 ,   0 ,   0 ,  62 ,   2 ,  60 ,   2 ,  60 ,   0 ,   0 ,  62 ,   2 ,   2 ,  60 ,   0 ,   0 ,  28 ,  34 ,  34 ,  28 ,   0 ,   0 , 254 ,  34 ,  34 ,  28 ,   0
DATA    0 ,  28 ,  34 ,  34 , 254 ,   0 ,   0 ,   0 ,  60 ,   2 ,   2 ,   0 ,   0 ,  36 ,  42 ,  42 ,  18 ,   0 ,   0 ,   2 ,  31 ,  34 ,   0 ,   0 ,   0 ,  30 ,  32 ,  32 ,  62 ,   0 ,  14 ,  16 ,  32 ,  16 ,  14 ,   0 ,  30 ,  32 ,  24 ,  32
DATA   30 ,   0 ,  34 ,  20 ,   8 ,  20 ,  34 ,   0 ,   0 , 158 , 160 , 160 , 126 ,   0 ,   0 ,  34 ,  50 ,  42 ,  38 ,   0 ,   0 ,   8 ,  62 ,  65 ,  65 ,   0 ,   0 ,   0 ,  63 ,   0 ,   0 ,   0 ,   0 ,  65 ,  65 ,  62 ,   8 ,   0 ,   0 ,   2
DATA    1 ,   2 ,   1 ,   0 ,  56 ,  36 ,  34 ,  36 ,  56 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,  56 ,  52 ,  37 ,  41 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0
DATA    0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,  18 ,  43 ,  43 ,  60 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0
DATA    0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,  56 ,  22 ,  21 ,  22 ,  56 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,  18 ,  42 ,  28 ,  42 ,  44 ,   0 ,  60 ,  10
DATA   63 ,  41 ,  33 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,  25 ,  36 ,  36 ,  25 ,   0 ,   0 ,  24 ,  37 ,  38 ,  24 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0
DATA    0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,  64 ,  60 ,  50 ,  38 ,  30 ,   1 ,   0 ,  42 ,  61 ,  41 ,  34 ,   0 ,  62 ,  41 ,  37 ,  30 ,   1 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0
DATA    0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0
DATA    0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,   0 ,  32 ,  23 ,   8 ,  36 ,  54 ,  45 ,  16 ,  11 ,   4 ,  26 ,  17 ,  56

SUB HentFont

RESTORE Font
FOR X = 0 TO 839
  READ a
  Alfabet(X) = CHR$(a)
NEXT X

END SUB

SUB skriv (Tekst AS STRING, X%, Y%, Fontfarve%, Stoerrelse%, Skygge%, tid!)

'************************************************************************
'       Parametrene til "SKRIV":
'************************************************************************
'       Tekst           der er teksten som skal skrives
'       X%              der er overkanten af skriftens Xkoordinat
'                       skriver du -1 centreres teksten
'       Y%              der er venstrekanten af skriftens Ykoordinat
'       Fontfarve%      der er fontens farve.
'                       hvis den er -1 s farves fonten metallisk
'                       Hvis den er -2 s tndes der ild i den med farverne
'                       som angivet i Ildfarver-typen
'       Stoerrelse%     er antal pixels i en stregtykkelse
'       Skygge%         her skriver du 0 hvis du ingen skygge vil have -
'                       ellers 1 for en sort skygge.
'       Tid!            Hvis teksten skal forsvinde efter noget tid
'                       ellers 0
'************************************************************************
WHILE LEN(INKEY$): WEND 'Rydder tastaturbufferen

'hvis X = -1 s skal der centreres
IF X% = -1 THEN X% = (SkaermBreddeIPixels% - LEN(Tekst) * Stoerrelse% * 6) / 2

'Hvis fontfarve% = -1 s skrives der med disse farver

FOR Y = 0 TO 7
  IF Y <> 2 THEN
    Farve(Y) = 7
  ELSE
    Farve(Y) = 15
  END IF
NEXT Y

'Hvis fontfarve% = -2 s skrives der med farve 63 for at f fuld farve p
IF Fontfarve% = -2 THEN
  SkrivFarve% = 63
ELSE
  SkrivFarve% = Fontfarve%
END IF


'Frst tegnes skyggen p skrmen hvis skyggeparametren er andet end 0
IF Skygge% THEN
  FOR bogstav = 1 TO LEN(Tekst)
     a = ASC(MID$(Tekst, bogstav, 1)) - 33
     IF a >= 0 AND a <= 140 THEN
      FOR X = 0 TO 5
          FOR Y = 0 TO 7
            IF Stoerrelse% = 1 THEN
              IF ASC(Alfabet(a * 6 + X)) AND Tabel(Y) THEN PSET (X% + (bogstav - 1) * 6 + X + 1, Y% + Y + 1), 0
            ELSE
              IF ASC(Alfabet(a * 6 + X)) AND Tabel(Y) THEN LINE (X% + ((bogstav - 1) * 6 + X + 1) * Stoerrelse%, Y% + (Y + 1) * Stoerrelse%)-STEP(Stoerrelse% - 1, Stoerrelse% - 1), 0, BF
            END IF
          NEXT Y
        NEXT X
    END IF
  NEXT bogstav
END IF

FOR bogstav = 1 TO LEN(Tekst)
   a = ASC(MID$(Tekst, bogstav, 1)) - 33
   IF a >= 0 AND a <= 140 THEN
    FOR X = 0 TO 5
        FOR Y = 0 TO 7
          IF Stoerrelse% = 1 THEN
            IF Fontfarve% = -1 THEN
              IF ASC(Alfabet(a * 6 + X)) AND Tabel(Y) THEN PSET (X% + (bogstav - 1) * 6 + X, Y% + Y), Farve(Y)
            ELSE
              IF ASC(Alfabet(a * 6 + X)) AND Tabel(Y) THEN PSET (X% + (bogstav - 1) * 6 + X, Y% + Y), SkrivFarve%
            END IF
          ELSE
            IF Fontfarve% = -1 THEN
              IF ASC(Alfabet(a * 6 + X)) AND Tabel(Y) THEN LINE (X% + ((bogstav - 1) * 6 + X) * Stoerrelse%, Y% + Y * Stoerrelse%)-STEP(Stoerrelse% - 1, Stoerrelse% - 1), Farve(Y), BF
            ELSE
              IF ASC(Alfabet(a * 6 + X)) AND Tabel(Y) THEN LINE (X% + ((bogstav - 1) * 6 + X) * Stoerrelse%, Y% + Y * Stoerrelse%)-STEP(Stoerrelse% - 1, Stoerrelse% - 1), SkrivFarve%, BF
            END IF
          END IF
        NEXT Y
      NEXT X
  END IF
NEXT bogstav

IF Fontfarve% <> -2 THEN
  StartTid! = TIMER
  DO
  LOOP WHILE TIMER - StartTid! < tid! AND LEN(INKEY$) = 0
  EXIT SUB
END IF

venstre% = X% - 5
Bredde% = LEN(Tekst) * Stoerrelse% * 6 + 10
Bund% = Y% + (Stoerrelse% - 1)
Hoejde% = 20
'Laver paletten fra 0 til 63 - fra sort til den nuance som RGB vrdierne angiver
FOR FarveTaeller% = 1 TO 63
  FarveTal! = FarveTaeller% / 64
  OUT &H3C8, FarveTaeller%
  OUT &H3C9, INT(IldFarver.Roed * FarveTal!)
  OUT &H3C9, INT(IldFarver.Groen * FarveTal!)
  OUT &H3C9, INT(IldFarver.Blaa * FarveTal!)
NEXT FarveTaeller%

DIM Tilfaeldig(0 TO 9) AS INTEGER
FOR X = 0 TO 9
  Tilfaeldig(X) = INT(RND * 8) + 2
NEXT X

DEF SEG = &HA000
BraendNed% = 0
StartTid = TIMER
TempBund% = Bund%       'Til at huske hvor bunden startede
DO
  Bund% = TempBund% + BraendNed% \ 10
  FOR Y& = Bund% - Hoejde% TO Bund%
    FOR X& = venstre% TO venstre% + Bredde%
        Taeller = (Taeller + 1) MOD 9
        Farve% = PEEK(Y& * 320 + X&) - Tilfaeldig(Taeller)
        IF Farve% < 0 THEN Farve% = 0
        POKE (X& + (RND * 3 - 1) + (Y& - 1) * 320), Farve%
    NEXT X&
  NEXT Y&
  IF TIMER - StartTid > tid! THEN
    IF HvilkenGangIgennem% THEN
      BraendNed% = BraendNed% + 1
      IF BraendNed% >= Stoerrelse% * 60 + 40 THEN EXIT DO
    ELSE
      HvilkenGangIgennem% = HvilkenGangIgennem% + 1
    END IF
  END IF
LOOP WHILE LEN(INKEY$) = 0
LINE (venstre%, TempBund% + 8 * Stoerrelse%)-STEP(Bredde%, -(Hoejde% + 8 * Stoerrelse%)), 0, BF



END SUB

SUB VisFil (Filnavn AS STRING, AntalLinierIFilen%, VenstreMargin%, TopMargin%, Fontfarve%, Stoerrelse%, Skygge%, tid!)

'************************************************************************
' Hvis du vil hente ind fra en tekstfil kan du gre det med flgende rutine:
'************************************************************************
'       Parametrene til "VISFIL":
'************************************************************************
'       Filnavn                 navnet p filen som skal skrives
'       AntalLinierIFilen%      Antallet af linier der skal vises
'       VenstreMargin%          Venstre margin i pixels
'                               skriver du minus 1 s centreres teksten
'       TopMargin%              Top margin i pixels
'
'       FontFarve%
'       Stoerrelse%
'       og Skygge%              som i Skriv!         
'       Tid!                    som i skriv - hvor lang tid skal der pauses
'************************************************************************
'
OPEN Filnavn FOR INPUT AS #1    'Her skal du selv skrive filnavnet
  FOR Linie = 0 TO AntalLinierIFilen%
    IF EOF(1) THEN EXIT FOR
    LINE INPUT #1, Tekstlinie$
    skriv Tekstlinie$, -1, TopMargin% + 8 * Linie * Stoerrelse%, Fontfarve%, Stoerrelse%, Skygge%, 0
  NEXT Linie
CLOSE #1
StartTid! = TIMER
DO
LOOP WHILE TIMER - StartTid! < tid!
END SUB

